package com.casic.dcms.view.upload;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityBriefCaseBinding;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.CaseLargeTypeBean;
import com.casic.dcms.model.CaseSmallTypeBean;
import com.casic.dcms.utils.PictureSelectorHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ViewGroupKit;
import com.casic.dcms.utils.callback.ISelectorListener;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.map.ArcGISMapActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.casic.dcms.vm.CommonDataViewModel;
import com.casic.dcms.vm.UploadViewModel;
import com.luck.picture.lib.entity.LocalMedia;
import com.pengxh.androidx.lite.adapter.EditableImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.kit.ContextKit;
import com.pengxh.androidx.lite.kit.IntKit;
import com.pengxh.androidx.lite.kit.StringKit;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.LoadingDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIBottomSheet;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class BriefCaseActivity extends AndroidxBaseActivity<ActivityBriefCaseBinding> {

    private final Context context = BriefCaseActivity.this;
    private final ArrayList<String> realPaths = new ArrayList<>();//真是图片路径
    private final List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private final Queue<LocalMedia> uploadQueue = new LinkedList<>(); // 用于存储待上传的图片
    private boolean isUploading = false; // 标记是否正在上传图片
    private CaseViewModel caseViewModel;
    private CommonDataViewModel commonDataViewModel;
    private UploadViewModel uploadViewModel;
    private List<CaseLargeTypeBean.DataBean> largeTypeBeans = new ArrayList<>();
    private List<CaseSmallTypeBean.DataBean> smallTypeBeans = new ArrayList<>();
    private EditableImageAdapter imageAdapter;
    private String eorc = "";
    private String typeCode = "";
    private String typeDetailCode = "";//默认值，防止用户不选择直接跳过
    private String gridId;

    private final ActivityResultLauncher<Intent> quickCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");

                binding.longitudeView.setText(String.valueOf(longitude));
                binding.latitudeView.setText(String.valueOf(latitude));
                binding.communityNameView.setText(community);
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        ViewGroupKit.initImmersionBar(binding.rootView, this, true, R.color.white);

        binding.titleBarLayout.titleView.setText("快速上报");
        binding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        caseViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    LoadingDialog.show(BriefCaseActivity.this, "案卷提交中，请稍后...");
                } else if (loadState == LoadState.Success) {
                    LoadingDialog.dismiss();
                    StringKit.show(context, "案卷提交成功");
                    finish();
                } else {
                    StringKit.show(context, "提交失败，请重试");
                    LoadingDialog.dismiss();
                }
            }
        });

        uploadViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    StringKit.show(BriefCaseActivity.this, "上传中，请稍后...");
                }
            }
        });
    }

    @Override
    public void initOnCreate(@Nullable Bundle savedInstanceState) {
        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);

        commonDataViewModel = new ViewModelProvider(this).get(CommonDataViewModel.class);
        commonDataViewModel.largeTypeModel.observe(this, new Observer<CaseLargeTypeBean>() {
            @Override
            public void onChanged(CaseLargeTypeBean typeBean) {
                if (typeBean.getCode() == 200) {
                    //设置大类数据
                    largeTypeBeans = typeBean.getData();
                }
            }
        });
        commonDataViewModel.smallTypeModel.observe(this, new Observer<CaseSmallTypeBean>() {
            @Override
            public void onChanged(CaseSmallTypeBean typeBean) {
                if (typeBean.getCode() == 200) {
                    //设置小类数据
                    smallTypeBeans = typeBean.getData();
                }
            }
        });

        uploadViewModel = new ViewModelProvider(this).get(UploadViewModel.class);
        uploadViewModel.imageModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                isUploading = false;
                if (resultBean.getCode() == 200) {
                    String url = resultBean.getData();
                    imageList.add(url);
                    int oldSize = realPaths.size();
                    realPaths.add(StringHelper.appendCompleteURL(url));
                    imageAdapter.notifyItemRangeChanged(oldSize, 1);
                    startUploadNextImage(); // 上传下一张图片
                } else {
                    StringKit.show(context, "图片上传失败，请重试");
                }
            }
        });

        int width = ContextKit.getScreenWidth(this) - IntKit.dp2px(this, 20);
        imageAdapter = new EditableImageAdapter(this, realPaths, width, 2, 3);
        binding.addImageRecyclerView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        /**
         * 选择案卷类型
         * */
        binding.caseClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new QMUIBottomSheet.BottomListSheetBuilder(context)
                        .setTitle("案卷类型")
                        .addItem("事件")
                        .addItem("部件")
                        .setGravityCenter(true)
                        .setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                            @Override
                            public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                                dialog.dismiss();
                                binding.caseClassView.setText(tag);
                                //获取案卷大类
                                commonDataViewModel.getLargeType(context, String.valueOf(position + 1));
                                //清空大小类
                                binding.caseLargeClassView.setText("");
                                binding.caseSmallClassView.setText("");
                            }
                        }).build().show();
            }
        });

        /**
         * 选择案卷大类
         * */
        binding.caseLargeClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (largeTypeBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(context);
                    sheetBuilder.setTitle("案卷大类");
                    for (CaseLargeTypeBean.DataBean dataBean : largeTypeBeans) {
                        sheetBuilder.addItem(dataBean.getTypeName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            binding.caseLargeClassView.setText(tag);
                            //清空小类
                            binding.caseSmallClassView.setText("");

                            //获取案卷小类
                            CaseLargeTypeBean.DataBean dataBean = largeTypeBeans.get(position);
                            eorc = dataBean.getEorc();
                            typeCode = dataBean.getTypeCode();
                            String typeId = dataBean.getId();

                            commonDataViewModel.getSmallType(context, eorc, typeId);
                        }
                    }).build().show();
                } else {
                    StringKit.show(context, "请先选择案卷类型");
                }
            }
        });

        /**
         * 选择案卷小类
         * */
        binding.caseSmallClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (smallTypeBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(context);
                    sheetBuilder.setTitle("案卷小类");
                    for (CaseSmallTypeBean.DataBean dataBean : smallTypeBeans) {
                        sheetBuilder.addItem(dataBean.getTypeDetailName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            binding.caseSmallClassView.setText(tag);
                            typeDetailCode = smallTypeBeans.get(position).getTypeDetailCode();
                        }
                    }).build().show();
                } else {
                    StringKit.show(context, "请先选择案卷大类");
                }
            }
        });

        /**
         * 选择经纬度
         * */
        binding.locationMapView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //根据情况加载不同图层
                String type = binding.caseClassView.getText().toString();
                if (type.equals("")) {
                    StringKit.show(context, "请先选择案卷类型");
                    return;
                }
                Intent intent = new Intent(context, ArcGISMapActivity.class);
                intent.putExtra("type", type);
                quickCaseLauncher.launch(intent);
            }
        });

        /**
         * 图片九宫格事件处理
         * */
        imageAdapter.setOnItemClickListener(new EditableImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                PictureSelectorHelper.selectPicture(context, 2, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        uploadQueue.addAll(result); // 将选中的图片加入队列
                        startUploadNextImage();
                    }
                });
            }

            @Override
            public void onItemClick(int position) {
                if (realPaths.get(position).isEmpty()) {
                    StringKit.show(context, "图片加载失败，无法查看大图");
                } else {
                    ContextKit.navigatePageTo(context, BigImageActivity.class, position, realPaths);
                }
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                realPaths.remove(position);
                imageAdapter.notifyItemRemoved(position);
                imageAdapter.notifyItemRangeChanged(position, realPaths.size() - position);
            }
        });

        binding.submitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                submitCase();
            }
        });
    }

    private void startUploadNextImage() {
        if (isUploading || uploadQueue.isEmpty()) {
            return;
        }

        isUploading = true;
        LocalMedia media = uploadQueue.poll();
        if (media != null) {
            uploadViewModel.uploadImage(this, new File(media.getRealPath()));
        } else {
            isUploading = false;
        }
    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = binding.longitudeView.getText().toString();
        String latitude = binding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            StringKit.show(this, "经纬度异常，请重新选择位置");
            return;
        }
        if (eorc.equals("") || typeCode.equals("")) {
            StringKit.show(this, "案卷大类还未选择");
            return;
        }
        if (typeDetailCode.equals("")) {
            StringKit.show(this, "案卷小类还未选择");
            return;
        }
        if (TextUtils.isEmpty(gridId)) {
            StringKit.show(this, "网格ID异常，请重新地图选点");
            return;
        }
        String fieldIntro = binding.caseLocationView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(fieldIntro)) {
            StringKit.show(this, "案卷地点还未填写");
            return;
        }
        String description = binding.caseDetailEditView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(description)) {
            StringKit.show(this, "案卷情况还未填写");
            return;
        }
        if (imageAdapter.getItemCount() < 1) {
            StringKit.show(this, "至少上传一张图片");
            return;
        }

        caseViewModel.submitCase(this, "0", "0", longitude, latitude,
                "1", "1", eorc, typeCode, typeDetailCode,
                gridId.substring(0, 6),
                gridId.substring(0, 9),
                gridId.substring(0, 12),
                gridId, description, fieldIntro,
                StringHelper.reformatURL(imageList), "", "", 0, 0);
    }
}